package com.indiscale.fdo.manager.service.authentication;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.servlet.HandlerInterceptor;

public class AuthTokenInterceptor implements HandlerInterceptor {
  private final AuthToken authToken;

  @Override
  public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler)
      throws Exception {
    String header = request.getHeader("authentication");
    if (header != null && header.startsWith("Bearer ")) {
      authToken.setToken(header.substring(7));
    }
    return true;
  }

  public AuthTokenInterceptor(AuthToken authToken) {
    this.authToken = authToken;
  }

  @Bean
  @Scope(value = WebApplicationContext.SCOPE_REQUEST, proxyMode = ScopedProxyMode.TARGET_CLASS)
  AuthToken authToken() {
    return new AuthToken();
  }
}
