package com.indiscale.fdo.manager.service.repositories;

import org.assertj.core.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.boot.test.web.server.LocalServerPort;

/** Test the {@link RepositoriesImpl} class */
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
public class RepositoriesTest {

  @Autowired private RepositoriesImpl repositories;

  @LocalServerPort private int port;

  @Autowired private TestRestTemplate restTemplate;

  @Value("${server.servlet.context-path}")
  private String contextPath;

  @Test
  void index() {
    Assertions.assertThat(repositories).isNotNull();
  }

  @Test
  void indexResultTest() {
    Assertions.assertThat(
            restTemplate.getForObject(
                "http://localhost:" + port + contextPath + "/repositories", String.class))
        .contains("data");
  }
}
